Bug 622060 - ICE compiling python3 with the --with-computed-gotos configure flag
Summary: ICE compiling python3 with the --with-computed-gotos configure flag
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: gcc   
(Show other bugs)
Version: rawhide
Hardware: All
OS: Linux
low
medium
Target Milestone: ---
Assignee: Jakub Jelinek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: 566770
TreeView+ depends on / blocked
 
Reported: 2010-08-06 22:32 UTC by Toshio Ernie Kuratomi
Modified: 2010-08-19 01:04 UTC (History)
4 users (show)

Fixed In Version: gcc-4.5.1-1.fc14
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: 566770
Environment:
Last Closed: 2010-08-19 01:04:30 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
preprocessed output from gcc (482.19 KB, text/plain)
2010-08-06 22:33 UTC, Toshio Ernie Kuratomi
no flags Details

Description Toshio Ernie Kuratomi 2010-08-06 22:32:47 UTC
Python3 has a configure switch --with-computed-gotos that uses the gcc computed goto extension as an optimization.  When we attempt to enable that in rawhide, it causes an internal compiler error.  Cloning the relevant portions of the python RFE here:

--- Additional comment from a.badger@gmail.com on 2010-08-06 17:20:51 EDT ---

Setting to rawhide again -- we'll apply this for the F15 cycle starting now and see how it goes.  I've verified that the patch from http://bugs.python.org/issue6603

has been applied in the tarball we're using.  I didn't take benchmarks but we can do that anytime during the F15 cycle by running benchmarks, turning off computed-goto, rerunning benchmarks.

There's a %global at the top of the spec to toggle this on and off in the build.  Just change:

%global with_computed_gotos yes
==>
%global with_computed_gotos no

I've kicked off a build with computed-gotos yes.  I' need to compare test suite output to the last build without computed-gotos when it completes.

https://koji.fedoraproject.org/koji/buildinfo?buildID=181256
http://koji.fedoraproject.org/koji/taskinfo?taskID=2386306

--- Additional comment from dmalcolm@redhat.com on 2010-08-06 17:35:56 EDT ---

Builds failed with internal compiler errors:

on x86_64:
http://koji.fedoraproject.org/koji/getfile?taskID=2386310&name=build.log
gcc -pthread -c -fno-strict-aliasing -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector --param=ssp-buffer-size=4 -m64 -mtune=generic -D_GNU_SOURCE -fPIC -fwrapv    -I. -IInclude -I/builddir/build/BUILD/Python-3.1.2/Include -I/usr/lib64/libffi-3.0.9/include   -fPIC -DPy_BUILD_CORE -o Python/ceval.o /builddir/build/BUILD/Python-3.1.2/Python/ceval.c
  [snip parallel tasks]
/builddir/build/BUILD/Python-3.1.2/Python/ceval.c: In function 'PyEval_EvalFrameEx':
/builddir/build/BUILD/Python-3.1.2/Python/ceval.c:3004:1: internal compiler error: in save_call_clobbered_regs, at caller-save.c:911
Please submit a full bug report,
with preprocessed source if appropriate.
See <http://bugzilla.redhat.com/bugzilla> for instructions.
Preprocessed source stored into /tmp/ccQpsjeF.out file, please attach this to your bugreport.
make: *** [Python/ceval.o] Error 1


on i386:
http://koji.fedoraproject.org/koji/getfile?taskID=2386311&name=build.log
gcc -pthread -c -fno-strict-aliasing -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector --param=ssp-buffer-size=4 -m32 -march=i686 -mtune=atom -fasynchronous-unwind-tables -D_GNU_SOURCE -fPIC -fwrapv    -I. -IInclude -I/builddir/build/BUILD/Python-3.1.2/Include -I/usr/lib/libffi-3.0.9/include   -fPIC -DPy_BUILD_CORE -o Python/ceval.o /builddir/build/BUILD/Python-3.1.2/Python/ceval.c
  [snip parallel tasks]
/builddir/build/BUILD/Python-3.1.2/Python/ceval.c: In function 'PyEval_EvalFrameEx':
/builddir/build/BUILD/Python-3.1.2/Python/ceval.c:3004:1: internal compiler error: in save_call_clobbered_regs, at caller-save.c:911

--- Additional comment from a.badger@gmail.com on 2010-08-06 18:22:45 EDT ---

Created an attachment (id=437273)
preprocessed output from gcc

Here's the output taken from the buildroot

Comment 1 Toshio Ernie Kuratomi 2010-08-06 22:33:40 UTC
Created attachment 437276 [details]
preprocessed output from gcc

Comment 2 Fedora Update System 2010-08-13 06:48:46 UTC
gcc-4.5.1-1.fc14,libtool-2.2.10-3.fc14 has been submitted as an update for Fedora 14.
http://admin.fedoraproject.org/updates/gcc-4.5.1-1.fc14,libtool-2.2.10-3.fc14

Comment 3 Toshio Ernie Kuratomi 2010-08-13 19:26:56 UTC
Hey Jakub, is it okay to tag this and the libtool update into f15 as well so I can try to build python3 again?

If you like I can tag it into dist-f15, do the python3 build, then untag from dist-f15.  That way the latest package in dist-f14 will continue to propagate to dist-f15.

Comment 4 Fedora Update System 2010-08-19 01:04:16 UTC
gcc-4.5.1-1.fc14, libtool-2.2.10-3.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.